package com.dtai.gwt;

import java.net.*;
import java.io.*;

/**
 * A URL stream handler for all protocols, used to return our
 * dummy implementation of URLConnection to open up a local
 * file when called upon.
 *
 * @version	1.1
 * @author	DTAI, Incorporated
 */
class AmURLStreamHandler extends URLStreamHandler {

    /**
     * URLConnection
     * @param url
     * @return URLConnection
     */
    protected final URLConnection openConnection( URL url ) throws IOException {
        if ( url.getProtocol().equals( "file" ) ) {
            return new AmFileURLConnection( url );
        }
        else if ( url.getProtocol().equals( "http" ) ) {
            return new AmHttpURLConnection( url );
        }
        else {
            throw new IOException(
                "Cannot open URL connection for protocol "+url.getProtocol()+
                "\nURL is "+url );
        }
    }
}

