package com.dtai.gwt;

import java11.awt.*;
import java11.awt.event.*;
import java.awt.*;
//import java.awt.event.*;
class DialogWrapper extends Dialog {

    private Frame frame;
    private boolean badMac = false;
    private boolean wasRepositioned = false;
    GadgetDialog shell;

    public DialogWrapper(Frame frame, String title, boolean trueModal, GadgetDialog shell) {
        super(frame,title,trueModal);
        setBackground(shell.getBackground());
        this.frame = frame;
        this.shell = shell;
        setupEventGrabberKludge(shell);
        add( "Center", shell );
        hide();
    }

    private void setupEventGrabberKludge( GadgetShell shell ) {
        String osName = "";
        double version = 0.0;
        double mrjVersion = 0.0;
        try {
            osName = System.getProperty("os.name");
        }
        catch ( SecurityException se ) {
        }
        if (osName.startsWith("Mac")) {
            try {
                String vs = System.getProperty("java.version").trim();
                int dot = vs.indexOf('.');
                if (dot >= 0) {
                    dot = vs.indexOf('.',dot+1);
                }
                if (dot >= 0) {
                    vs = vs.substring(0,dot);
                }
                version = Double.valueOf(vs).doubleValue();
            }
            catch ( SecurityException se ) {
            }
            catch ( NumberFormatException nfe ) {
            }
            try {
                String vs = System.getProperty("mrj.version");
    			if (vs == null)
    				vs = "";
                vs = vs.trim();
                int dot = vs.indexOf('.');
                if (dot >= 0) {
                    dot = vs.indexOf('.',dot+1);
                }
                if (dot >= 0) {
                    vs = vs.substring(0,dot);
                }
                version = Double.valueOf(vs).doubleValue();
            }
            catch ( SecurityException se ) {
            }
            catch ( NumberFormatException nfe ) {
            }
            if ((version < 1.1) && (mrjVersion < 1.5)) {
                badMac = true;
            }
        }
	}

	/**
     * handleEvent
     * @param evt - TBD
     * @return boolean result
     */
	public boolean handleEvent( Event evt ) {
        if ( evt.id == Event.WINDOW_DESTROY ) {
            shell.processEvent( new WindowEvent( shell, evt, WindowEvent.WINDOW_CLOSING ) );
            return true;
        }
        else if ( evt.id == Event.WINDOW_ICONIFY ) {
            shell.processEvent( new WindowEvent( shell, evt, WindowEvent.WINDOW_ICONIFIED ) );
            return true;
        }
        else if ( evt.id == Event.WINDOW_DEICONIFY ) {
            shell.processEvent( new WindowEvent( shell, evt, WindowEvent.WINDOW_DEICONIFIED ) );
            return true;
        }
        else if ( evt.id == Event.WINDOW_EXPOSE ) {
            return false;
        }
        else if ( evt.id == Event.WINDOW_MOVED ) {
            return false;
        }
        else if ( badMac ) {
            if ( evt.id == Event.KEY_RELEASE ) {
                evt.id = Event.KEY_PRESS;
                shell.handleEvent( evt );
                evt.id = Event.KEY_RELEASE;
                shell.handleEvent( evt );
            }
            else if ( evt.id == Event.KEY_ACTION_RELEASE ) {
                evt.id = Event.KEY_ACTION;
                shell.handleEvent( evt );
                evt.id = Event.KEY_ACTION_RELEASE;
                shell.handleEvent( evt );
            }
            else if ( ( evt.id == Event.GOT_FOCUS ) ||
                      ( evt.id == Event.LOST_FOCUS ) ) {
                shell.handleEvent( evt );
            }
        }
        return false;
	}

	/**
	 * hide
	 */
	public void hide() {
	    super.hide();
	    Event e = new Event( shell, -1, shell );
	    WindowEvent we = new WindowEvent( shell, e, WindowEvent.WINDOW_CLOSED );
	    shell.processEvent( we );
	    if (frame != null) {
            frame.requestFocus();
        }
	}

	/**
	 * show
	 */
	public void show() {
		/* There's a lot of redundant packing and positioning here,
		 * and in the thread, if this is the first time...(wasRepositioned
		 * is false).  But that's because some platforms don't handle
		 * it right the first time.
		 */
	    if ( ! wasRepositioned ) {
			positionDialog();
		}
		if (super.isModal()) {
    	    shell.processEvent( new WindowEvent( shell, new Event( shell, -1, shell ),
    	                                         WindowEvent.WINDOW_OPENED ) );
    	    super.show();
		} else {
    	    super.show();
    	    shell.processEvent( new WindowEvent( shell, new Event( shell, -1, shell ),
    	                                         WindowEvent.WINDOW_OPENED ) );
    	    if ( ! wasRepositioned ) {
    	        positionDialog();
    	        shell.forceFocus();
                shell.resetFocus();
                shell.requestFocus();
    			new PackThread( this ).run();
    	        wasRepositioned = true;
    	    }
    	    else {
        	    shell.resetFocus();
        	    shell.requestFocus();
        	}
        }
	}

	void positionDialog() {
	    shell.positionDialog(frame, this);
	}
}
