/****************************************************************
 **
 **  $Id: KeyBox.java,v 1.4 1998/09/17 02:03:57 ccp Exp $
 **
 **  $Source: /cvs/classes/signwriting/KeyBox.java,v $
 **
 ****************************************************************/

package org.signwriting;

import com.dtai.gwt.ButtonGadget;
import com.dtai.gwt.BorderGadget;

/**
 * KeyBox
 * @version 1.1
 * @author DTAI, Incorporated
 */
public class KeyBox extends ButtonGadget {

    private SignDisplay display;
    private BorderGadget disabledBorder;

    /**
     * Constructs a KeyBox.
     */
	public KeyBox() {
	    setFocusAllowed(false);
	    removeAll();
        display = new SignDisplay();
        display.setFixedSize(true);
	    add("Center",display);
	    disabledBorder = (BorderGadget)getUnarmedBorder().clone();
	    disabledBorder.setBorderType(BorderGadget.ETCHED_IN);
	    setEnabled(false);
	}

	public void clear() {
	    display.clear();
	    setEnabled(false);
	}

	public Sign getSign() {
	    return display.getSign();
	}

	public void setSignComponent(SignSymbol sym) {
	    setEnabled(true);
	    display.setSignComponent(sym);
	}

	public void addSignComponent(SignSymbol sym) {
	    setEnabled(true);
	    display.addSignComponent(sym);
	}

	public void setEnabled(boolean enabled) {
	    if (enabled != isEnabled()) {
	        if (enabled) {
	            setBorder(getUnarmedBorder());
	        } else {
	            setBorder(disabledBorder);
	        }
	    }
	    super.setEnabled(enabled);
	}
}
