package org.signwriting;

/**
 * Handles the byte swapping and other conversion issues of reading
 * the little-endian numbers from files created on the PC (usually in
 * Microsoft Pascal) to the big-endian numbers of Java
 */
public class PCNumbers {

    public static int makeInt(int byte1, int byte2, int byte3, int byte4) {
        return ((byte4<<24)|(byte3<<16)|(byte2<<8)|byte1);
    }

    public static short makeShort(int byte1, int byte2) {
        return (short)((byte2<<8)|byte1);
    }

    public static int makeUnsignedShort(int byte1, int byte2) {
        return (byte2<<8)|byte1;
    }

    public static int toUnsigned(byte signed) {
        if (signed >= 0) {
            return signed;
        }
        return (signed & 0x7f) | 0x80;
    }
}
